#ifndef _UNITECCTEST_H_
#define _UNITECCTEST_H_

#include <stdio.h>
#include <string.h>
#include "ecc_safeengine.h"
#ifdef _WINDOWS
#include <windows.h>
#define CRTDBG_MAP_ALLOC  
#include <stdlib.h>  
#include <crtdbg.h>
#else
#include "platform.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

#ifdef _WINDOWS
#pragma warning(disable:4047)
#pragma warning(disable:4996)
#pragma warning(disable:4024)
#endif /* _WINDOWS */

#ifndef MAX_PATH_LENGTH
#define MAX_PATH_LENGTH 256
#endif

#define K_PASS_MAXLEN			128		/* 󳤶 */

#define K_PRIKEY_MAXLEN			4096	/* ˽Կ󳤶 */
#define K_PUBKEY_MAXLEN			4096	/* Կ󳤶 */
#define K_CERTINFO_MAXLEN		4096	/* ֤󳤶 */
#define K_CERTCHAIN_MAXLEN		8192	/* ֤󳤶 */
#define K_PEMENC_MAXLEN			8192	/* PEM󳤶 */
#define K_PEMDEC_MAXLEN			8192	/* PEM󳤶 */
#define K_ENVOLPEENC_MAXLEN		4096	/* ŷ󳤶 */
#define K_ENVOLPEDEC_MAXLEN		4096	/* ŷ󳤶 */
#define K_SYMENC_MAXLEN			4096	/* ԳƼ󳤶 */
#define K_SYMDEC_MAXLEN			4096	/* Գƽ󳤶 */
#define K_ASYENC_MAXLEN			4096	/* ǶԳƼ󳤶 */
#define K_ASYDEC_MAXLEN			4096	/* ǶԳƽ󳤶 */
#define K_INTESDATA_MAXLEN		8192	/* ԭ󳤶 */
#define K_SIGNDATA_MAXLEN		4096	/* ǩ󳤶 */

#define K_STATIC_VAL_MAXLEN		4096	/* static󳤶 */

/* safeengine⺯ */
typedef long (*ESE_InitialSessionProc)(HSE *hSE, unsigned long privatekeydevicetype,  char *privatekeydeviceparameter, char *privatekeypassword,  unsigned long privatekeytimeout,  unsigned long certchaindevicetype,  char *certchaindeviceparameter,  char *certchainpassword );
typedef long (*ESE_VerifyCertificateProc)(HSE hSE, unsigned char *certificate, unsigned short length);
typedef long (*ESE_SetConfigurationProc)(HSE hSE, long mode);
typedef long (*ESE_ClearSessionProc)(HSE hSE);
typedef long (*ESE_ShowVersionProc)(HSE hSE, long *plModualNo, long *plVersion);
typedef long (*ESE_GetSelfCertificateProc)(HSE hSE, unsigned long devicetype,  char *deviceparameter, unsigned char *certificate,  unsigned short *certificatelength);
typedef long (*ESE_SignDataProc)(HSE hSE, unsigned char *origindata,  unsigned long length,  char *alg,  unsigned char *signeddata,  unsigned long  *signedlength );

typedef long (*ESE_DigestProc)(HSE hSE, unsigned char *data,  unsigned long length, char *alg,   
				unsigned char *digest, unsigned long  *digestlength );

typedef long (*ESE_DigestFileProc)(HSE hSE, unsigned char *filepath , char *alg,unsigned char *digest,  unsigned long  *digestlength);
typedef long (*ESE_VerifySignFileProc)(HSE hSE, unsigned char *filepath, char *alg,unsigned char *signeddata,unsigned long signedlength,unsigned char *ceritificate,  unsigned short certlength);

typedef long (*ESE_SignHashProc)(HSE hSE, unsigned char *hashdata, unsigned long hashlen, char *alg, 
				  unsigned char *signeddata, unsigned long *signedlength);

typedef long (*ESE_VerifySignDataProc)(HSE hSE, unsigned char *origindata,  
										unsigned long originlength,  char *alg, 
										unsigned char *signeddata,  unsigned long signedlength,  
										unsigned char *ceritificate,  unsigned short certlength);
typedef long (*ESE_SignData_P7Proc)( HSE hSE, unsigned char *origindata,unsigned long length, 
									 char *alg, unsigned char *cert, unsigned short certlength, unsigned char *p7,  unsigned long  *p7length);
typedef long (*ESE_VerifySignData_P7Proc)(HSE hSE, 
									  unsigned char *p7, 
									  unsigned long p7length, 
									  unsigned char * origindata,  
									  unsigned long *origindatalen,
									  unsigned char *cert, 
									  unsigned short *certlength, 
									  unsigned char *signature, 
									  unsigned long *signaturelength);

typedef long (*ESE_Envelope_P7Proc)(HSE hSE, unsigned char *indata,  unsigned long  inlength, 
								char *symalg,  char *asymalg, 
								unsigned char * outdata, unsigned long *outlength,  
								unsigned char *certificate,  unsigned short  certlength);

typedef long (*ESE_DecodeEnvelope_P7Proc)(HSE hSE, unsigned char *p7,  unsigned long  p7length, unsigned char * outdata, unsigned long *outlength);
typedef long (*ESE_VerifyCertificateOnlineProc)(HSE hSE, unsigned char *certificate, unsigned short length);
typedef long (*ESE_GetCertDetailProc)(HSE hSE, unsigned char *DerCert, unsigned short DerCertLen, unsigned short ItemNo, unsigned char *ItemValue, unsigned short *ItemLength);

typedef long (*ESE_SymEncryptProc)(HSE hSE, unsigned char* pbKey,unsigned long pbKeyLen,unsigned long ulAlgID,unsigned char* src, int srcLen, unsigned char* dst, int* dstLen);
typedef long (*ESE_SymDecryptProc)(HSE hSE, unsigned char* pbKey,unsigned long pbKeyLen,unsigned long ulAlgID,unsigned char* src, int srcLen, unsigned char* dst, int* dstLen);

typedef long (*ESE_SymEncryptExProc)(HSE hSE, 
					  unsigned char* cert,unsigned long certLen,
					  unsigned long ulAlgID,
					  unsigned char* src, int srcLen, 
					  unsigned char* dst, int* dstLen,
					  unsigned char* pData,int* pDataLen);

typedef long (*ESE_SymDecryptExProc)(HSE hSE,
					  unsigned long ulAlgID,
					  unsigned char* pData,int pDataLen,
					  unsigned char* inData,int inDataLen,
					  unsigned char* outData,int* outDataLen);


typedef long (*ESE_GetCertValidDateProc)(HSE hSE, unsigned char *cert, unsigned short certlen, long *datanum);
typedef long (*ESE_GetCertUsageProc)(HSE hSE,unsigned char *cert, unsigned short certlen, unsigned long *lKeyUsage);
typedef long (*ESE_GetCertInfoByOIDProc)(HSE hSE, unsigned char *dercert, unsigned short dercertlen, char *oid, char *info, unsigned short *infolen);
typedef long (*ESE_EncodeCertProc)( HSE hSE, X500_NAME_INFO pX500info, int certType,unsigned char* cert,unsigned short* certlen );
typedef long (*ESE_GenKeyPairProc)(HSE hSE, char *keyName, char *password, char *alg, char *param, unsigned char *DerPubkey, int *DerPubkeyLen, unsigned char *DerPrikey, int *DerPrikeyLen);
typedef long (*ESE_EncodePkcs10Proc)(HSE hSE, PKCS10_INFO * p10Info, int X500NameStringType, char *alg, unsigned char *der_pkcs10, int *der_pkcs10Size);
typedef long (*ESE_DecodePkcs10Proc)(HSE hSE, unsigned char *der_pkcs10, int der_pkcs10Size, PKCS10_INFO *p10Info);
typedef long (*ESE_PEMEncodeProc)(HSE hSE, unsigned char *indata, unsigned long indatalen, unsigned char *pemdata, unsigned long *pemlen);
typedef long (*ESE_PEMDecodeProc)(HSE hSE, unsigned char *pemdata, unsigned long pemlen, unsigned char *outdata, unsigned long *outlen);
typedef long (*ESE_GenRandomBytesProc)(HSE hSE, unsigned char *randombytes, int randombyteslen);
typedef long (*ESE_ListAllDeviceProc)(DEVICE_LIST* devList, int* devNum);
typedef long (*ESE_ListPlugDeviceProc)(DEVICE_LIST* devList, int* devNum);
typedef long (*ESE_GetDevicePortListProc)(unsigned long devicetype, int* devNum, char *PortStatusBuffer, int iBufferLen);
typedef long (*ESE_GetPublicKeyProc)(HSE hSE, char* filename, unsigned char *pubkey, int *pubkeyLen);
typedef long (*ESE_SignFileProc)( HSE hSE, unsigned char *filepath, char *alg, unsigned char *signeddata,  unsigned long  *signedlength );

typedef long (*ESE_SymEncFileProc)( HSE hSE, unsigned char* symkey, unsigned long symkeylen, unsigned char* infilepath, char* alg, unsigned char* outfilepath );
typedef long (*ESE_SymDecFileProc)( HSE hSE, unsigned char* symkey, unsigned long symkeylen, unsigned char* encfilepath, char* alg, unsigned char* decfilepath );


/* ecc_readcert.dll */
typedef long (*InitICCardProc)(unsigned long devicetype, char *deviceparameter, char *password, char* adminPin, int adminPinLockCount, char* userPin, int userPinLockCount);
typedef long (*WriteKeyPairProc)(char * eccobj, unsigned long devicetype, char *deviceparameter, char* password, unsigned char *privatekey, unsigned short privatekeylength, unsigned char *publickey, unsigned short publickeylength);
typedef long (*ChangePasswordProc)(unsigned long devicetype, char *deviceparameter, char *oldpassword, char *newpassword, int type);
typedef long (*GetPublickeyProc)(unsigned long devicetype, char *deviceparameter, unsigned char *pubkey, unsigned short *pubkeylen);
typedef long (*WriteCertificateProc)(unsigned long devicetype, char *deviceparameter, char *password, unsigned char *certificate, unsigned short certificatelength);
typedef long (*GetCertificateProc)(unsigned long devicetype, char *deviceparameter, unsigned char *certificate, unsigned short *certificatelength);
typedef long (*WriteCertificateChainProc)(unsigned long devicetype, char *deviceparameter, char *password, unsigned char *certificatechain, unsigned short certificatechainlength);
typedef long (*GetCertificateChainProc)(unsigned long devicetype, char *deviceparameter, unsigned char *certificatechain, unsigned short *certificatechainlength);
typedef long (*WriteCardInfoProc)(unsigned long devicetype, char *deviceparameter, char *password, unsigned char *info, unsigned short length);
typedef long (*GetCardInfoProc)(unsigned long devicetype, char *deviceparameter, unsigned char *info, unsigned short *length);
typedef long (*UnlockDeviceProc)(unsigned long devicetype, char *deviceparameter, char *adminPin, char *newUserPin);
typedef long (*GetSerialNumberProc)(long devType, char* devParam, char* serialNumber);

ESE_InitialSessionProc ESE_InitialSession;
ESE_ClearSessionProc ESE_ClearSession;
ESE_ShowVersionProc ESE_ShowVersion;
ESE_VerifyCertificateOnlineProc ESE_VerifyCertificateOnline;
ESE_VerifyCertificateProc ESE_VerifyCertificate;
ESE_SetConfigurationProc ESE_SetConfiguration;
ESE_GetSelfCertificateProc ESE_GetSelfCertificate;
ESE_SignDataProc ESE_SignData;
ESE_VerifySignDataProc ESE_VerifySignData;
ESE_SignData_P7Proc ESE_SignData_P7;
ESE_VerifySignData_P7Proc ESE_VerifySignData_P7;
ESE_Envelope_P7Proc ESE_Envelope_P7;
ESE_DecodeEnvelope_P7Proc ESE_DecodeEnvelope_P7;
ESE_VerifyCertificateProc ESE_VerifyCertificate;
ESE_SetConfigurationProc ESE_SetConfiguration;
ESE_GetCertInfoByOIDProc ESE_GetCertInfoByOID;
ESE_GetCertDetailProc ESE_GetCertDetail;
ESE_SymEncryptProc ESE_SymEncrypt;
ESE_SymDecryptProc ESE_SymDecrypt;
ESE_SymEncryptExProc ESE_SymEncryptEx;
ESE_SymDecryptExProc ESE_SymDecryptEx;
ESE_GetCertValidDateProc ESE_GetCertValidDate;
ESE_GetCertUsageProc ESE_GetCertUsage;
ESE_GetCertInfoByOIDProc ESE_GetCertInfoByOID;
ESE_EncodeCertProc ESE_EncodeCert;
ESE_GenKeyPairProc ESE_GenKeyPair;
ESE_EncodePkcs10Proc ESE_EncodePkcs10;
ESE_DecodePkcs10Proc ESE_DecodePkcs10;
ESE_PEMEncodeProc ESE_PEMEncode;
ESE_PEMDecodeProc ESE_PEMDecode;
ESE_GenRandomBytesProc ESE_GenRandomBytes;
ESE_ListAllDeviceProc ESE_ListAllDevice;
ESE_ListPlugDeviceProc ESE_ListPlugDevice;
ESE_GetDevicePortListProc ESE_GetDevicePortList;
ESE_GetPublicKeyProc ESE_GetPublicKey;
ESE_DigestProc ESE_Digest;
ESE_DigestFileProc ESE_DigestFile;
ESE_VerifySignFileProc ESE_VerifySignFile;
ESE_SignHashProc ESE_SignHash;
ESE_SignFileProc ESE_SignFile;
//ESE_LargeDataEncProc ESE_LargeDataEnc;
//ESE_LargeDataDecProc ESE_LargeDataDec;
ESE_SymEncFileProc ESE_SymEncFile;
ESE_SymDecFileProc ESE_SymDecFile;

/*ecc_readcert*/
InitICCardProc InitICCard;
WriteKeyPairProc WriteKeyPair;
ChangePasswordProc ChangePassword;
GetPublickeyProc GetPublickey;
WriteCertificateProc WriteCertificate;
GetCertificateProc GetCertificate;
WriteCertificateChainProc WriteCertificateChain;
GetCertificateChainProc GetCertificateChain;
WriteCardInfoProc WriteCardInfo;
GetCardInfoProc GetCardInfo;
UnlockDeviceProc UnlockDevice;
GetSerialNumberProc GetSerialNumber;

HINSTANCE g_sl_safeengine;
HINSTANCE g_sl_readcert;
HINSTANCE g_sl_filestd;

int gIntTypeA;
int gIntTypeB;
int gIntTypeC;

uint8 g_prikeydata[K_PRIKEY_MAXLEN];			/* ˽Կ */
uint8 g_pubkeydata[K_PUBKEY_MAXLEN];			/* Կ */
uint8 g_certinfodata[K_CERTINFO_MAXLEN];		/* ֤ */
uint8 g_certchaindata[K_CERTCHAIN_MAXLEN];		/* ֤ */
uint8 g_pemencdata[K_PEMENC_MAXLEN];			/* PEM */
uint8 g_pemdecdata[K_PEMDEC_MAXLEN];			/* PEM */
uint8 g_envolpeencdata[K_ENVOLPEENC_MAXLEN];	/* ŷ */
uint8 g_envolpedecdata[K_ENVOLPEDEC_MAXLEN];	/* ŷ */
uint8 g_symencencdata[K_SYMENC_MAXLEN];			/* ԳƼ */
uint8 g_symdecdata[K_SYMDEC_MAXLEN];			/* Գƽ */
uint8 g_asyencdata[K_ASYENC_MAXLEN];			/* ǶԳƼ */
uint8 g_asydecdata[K_ASYDEC_MAXLEN];			/* ǶԳƽ */
uint8 g_indata[K_INTESDATA_MAXLEN];				/* ԭ */
uint8 g_signdata[K_SIGNDATA_MAXLEN];			/* ǩ */

uint32 g_prikeydectype;						/* ˽Կ豸type */
uint8 g_prikeydecparm[MAX_PATH_LENGTH];		/* ˽Կ豸 */
uint8 g_prikeydecpass[K_PASS_MAXLEN];		/* ˽Կ豸 */

uint32 g_certinfodectype;					/* ֤豸type */
uint8 g_certinfodecparm[MAX_PATH_LENGTH];	/* ֤豸 */
uint8 g_certinfodecpass[K_PASS_MAXLEN];		/* ֤豸 */

uint32 g_certchaindectype;					/* ֤豸type */
uint8 g_certchaindecparm[MAX_PATH_LENGTH];	/* ֤豸 */
uint8 g_certchaindecpass[K_PASS_MAXLEN];	/* ֤豸 */

uint32 g_retcode;

void LOAD_SAFEENGINE_DLL()
{
	g_sl_safeengine = LoadLibrary(SAFEENGINE_DLL_NAME);
	(!g_sl_safeengine) ? printf("load safeengine failed!!\n") : printf("load safeengine OK!!\n");
	g_sl_readcert = LoadLibrary(READCERT_DLL_NAME);
	(!g_sl_readcert) ? printf("load readcert failed!!\n") : printf("load readcert OK!!\n");
}

void LOAD_SAFEENGINE_API(HINSTANCE dllHandle)
{
	ESE_InitialSession = (ESE_InitialSessionProc)GetProcAddress(dllHandle, "ESE_InitialSession");
	ESE_ShowVersion = (ESE_ShowVersionProc)GetProcAddress(dllHandle, "ESE_ShowVersion");
	ESE_VerifyCertificate = (ESE_VerifyCertificateProc)GetProcAddress(dllHandle, "ESE_VerifyCertificate");
	ESE_SetConfiguration = (ESE_SetConfigurationProc)GetProcAddress(dllHandle, "ESE_SetConfiguration");
	ESE_GetSelfCertificate = (ESE_GetSelfCertificateProc)GetProcAddress(dllHandle, "ESE_GetSelfCertificate");
	ESE_SignData = (ESE_SignDataProc)GetProcAddress(dllHandle, "ESE_SignData");
	ESE_VerifySignData = (ESE_VerifySignDataProc)GetProcAddress(dllHandle, "ESE_VerifySignData");
	ESE_SignData_P7 = (ESE_SignData_P7Proc)GetProcAddress(dllHandle, "ESE_SignData_P7");
	ESE_VerifySignData_P7 = (ESE_VerifySignData_P7Proc)GetProcAddress(dllHandle, "ESE_VerifySignData_P7");
	ESE_Envelope_P7 = (ESE_Envelope_P7Proc)GetProcAddress(dllHandle, "ESE_Envelope_P7");
	ESE_DecodeEnvelope_P7 = (ESE_DecodeEnvelope_P7Proc)GetProcAddress(dllHandle, "ESE_DecodeEnvelope_P7");
	ESE_VerifyCertificateOnline = (ESE_VerifyCertificateOnlineProc)GetProcAddress(dllHandle, "ESE_VerifyCertificateOnline");
	ESE_SetConfiguration = (ESE_SetConfigurationProc)GetProcAddress(dllHandle, "ESE_SetConfiguration");
	ESE_GetCertInfoByOID = (ESE_GetCertInfoByOIDProc)GetProcAddress(dllHandle, "ESE_GetCertInfoByOID");
	ESE_GetCertDetail = (ESE_GetCertDetailProc)GetProcAddress(dllHandle, "ESE_GetCertDetail");
	ESE_SymEncrypt = (ESE_SymEncryptProc)GetProcAddress(dllHandle, "ESE_SymEncrypt");
	ESE_SymDecrypt = (ESE_SymDecryptProc)GetProcAddress(dllHandle, "ESE_SymDecrypt");
	ESE_SymEncryptEx = (ESE_SymEncryptExProc)GetProcAddress(dllHandle, "ESE_SymEncryptEx");
	ESE_SymDecryptEx = (ESE_SymDecryptExProc)GetProcAddress(dllHandle, "ESE_SymDecryptEx");
	ESE_GetCertValidDate = (ESE_GetCertValidDateProc)GetProcAddress(dllHandle, "ESE_GetCertValidDate");
	ESE_GetCertUsage = (ESE_GetCertUsageProc)GetProcAddress(dllHandle, "ESE_GetCertUsage");
	ESE_GetCertInfoByOID = (ESE_GetCertInfoByOIDProc)GetProcAddress(dllHandle, "ESE_GetCertInfoByOID");
	ESE_EncodeCert = (ESE_EncodeCertProc)GetProcAddress(dllHandle, "ESE_EncodeCert");
	ESE_ClearSession = (ESE_ClearSessionProc)GetProcAddress(dllHandle, "ESE_ClearSession");
	ESE_GenKeyPair = (ESE_GenKeyPairProc)GetProcAddress(dllHandle, "ESE_GenKeyPair");
	ESE_EncodePkcs10 = (ESE_EncodePkcs10Proc)GetProcAddress(dllHandle, "ESE_EncodePkcs10");
	ESE_DecodePkcs10 = (ESE_DecodePkcs10Proc)GetProcAddress(dllHandle, "ESE_DecodePkcs10");		
	ESE_PEMEncode = (ESE_PEMEncodeProc)GetProcAddress(dllHandle, "ESE_PEMEncode");
	ESE_PEMDecode = (ESE_PEMDecodeProc)GetProcAddress(dllHandle, "ESE_PEMDecode");
	ESE_GenRandomBytes = (ESE_GenRandomBytesProc)GetProcAddress(dllHandle, "ESE_GenRandomBytes");
	ESE_ListAllDevice = (ESE_ListAllDeviceProc)GetProcAddress(dllHandle, "ESE_ListAllDevice");
	ESE_ListPlugDevice = (ESE_ListPlugDeviceProc)GetProcAddress(dllHandle, "ESE_ListPlugDevice");
	ESE_GetDevicePortList = (ESE_GetDevicePortListProc)GetProcAddress(dllHandle, "ESE_GetDevicePortList");
	ESE_GetPublicKey = (ESE_GetPublicKeyProc)GetProcAddress(dllHandle, "ESE_GetPublicKey");
	ESE_DigestFile = (ESE_DigestFileProc)GetProcAddress(dllHandle, "ESE_DigestFile");
	ESE_Digest = (ESE_DigestProc)GetProcAddress(dllHandle, "ESE_Digest");
	ESE_VerifySignFile = (ESE_VerifySignFileProc)GetProcAddress(dllHandle, "ESE_VerifySignFile");
	ESE_SignHash = (ESE_SignHashProc)GetProcAddress(dllHandle, "ESE_SignHash");
	ESE_SignFile = (ESE_SignFileProc)GetProcAddress(dllHandle, "ESE_SignFile");
//	ESE_LargeDataEnc = (ESE_LargeDataEncProc)GetProcAddress(dllHandle, "ESE_LargeDataEnc");
//	ESE_LargeDataDec = (ESE_LargeDataDecProc)GetProcAddress(dllHandle, "ESE_LargeDataDec");	
	ESE_SymEncFile = (ESE_SymEncFileProc)GetProcAddress(dllHandle, "ESE_SymEncFile");
	ESE_SymDecFile = (ESE_SymDecFileProc)GetProcAddress(dllHandle, "ESE_SymDecFile");
}

void LOAD_READCERT_API(HINSTANCE dllHandle)
{
	InitICCard = (InitICCardProc)GetProcAddress(dllHandle, "InitICCard");
	WriteKeyPair = (WriteKeyPairProc)GetProcAddress(dllHandle, "WriteKeyPair");
	ChangePassword = (ChangePasswordProc)GetProcAddress(dllHandle, "ChangePassword");
	GetPublickey = (GetPublickeyProc)GetProcAddress(dllHandle, "GetPublickey");
	WriteCertificate = (WriteCertificateProc)GetProcAddress(dllHandle, "WriteCertificate");
	GetCertificate = (GetCertificateProc)GetProcAddress(dllHandle, "GetCertificate");
	WriteCertificateChain = (WriteCertificateChainProc)GetProcAddress(dllHandle, "WriteCertificateChain");
	GetCertificateChain = (GetCertificateChainProc)GetProcAddress(dllHandle, "GetCertificateChain");
	WriteCardInfo = (WriteCardInfoProc)GetProcAddress(dllHandle, "WriteCardInfo");
	GetCardInfo = (GetCardInfoProc)GetProcAddress(dllHandle, "GetCardInfo");
	UnlockDevice = (UnlockDeviceProc)GetProcAddress(dllHandle, "UnlockDevice");
	GetSerialNumber = (GetSerialNumberProc)GetProcAddress(dllHandle, "GetSerialNumber");
}


static long File_readEx(char* filename,unsigned char* buf,unsigned long *length)
{
#ifdef _WINDOWS
	HANDLE hFile;
	DWORD dwLen;

	if( (hFile=CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_ARCHIVE, NULL)) == INVALID_HANDLE_VALUE )
	{
		return (-1);
	}
	if( ((*length)=GetFileSize(hFile, NULL)) == 0xFFFFFFFF )
	{
		CloseHandle(hFile);
		return (-1);
	}
	if( ReadFile(hFile, buf, *length, &dwLen, NULL) == 0 )
	{
		CloseHandle(hFile);
		return (-1);
	}
	CloseHandle(hFile);

	return 0;
#else
	return -1;
#endif /* _WINDOWS */

}

#ifdef _WINDOWS
static long ReadDiskFile(const char *FilePath, unsigned char *FileContent, unsigned long *FileLen)
{
	FILE	*fp;

	if((fp=fopen(FilePath, "rb")) == NULL)
	{
		return(-1);
	}
	
	fseek(fp, 0, SEEK_END);
	*FileLen=ftell(fp);
	if (FileContent==NULL)
		return 0;

	fseek(fp, 0, SEEK_SET);

	if(fread(FileContent, 1, *FileLen, fp) != (*FileLen))
	{
		fclose(fp);
		fp=NULL;
		return(-1);
	}

	fclose(fp);
	fp=NULL;
	return(0);
}
#endif /* _WINDOWS */

static long File_writeEx(char* filename,unsigned char* buf,unsigned long length)
{
	FILE* tfpTmp=NULL;
	int tfilelen = 0;
	if((tfpTmp=fopen(filename,"wb+"))==NULL) return (-1);
	tfilelen=fwrite(buf,sizeof(unsigned char),length,tfpTmp);
	fclose(tfpTmp);
	tfpTmp=NULL;
	return 0;
}

static long File_writeExA(char* filename,int pnNo,char* optName,unsigned char* buf,unsigned long length)
{
	FILE* tfpTmp=NULL;
	char wFn[256];

	int tfilelen = 0;
	sprintf(wFn, "%s%d.%s", filename,pnNo,optName);

	if((tfpTmp=fopen(wFn,"wb+"))==NULL) return (-1);
	tfilelen=fwrite(buf,sizeof(unsigned char),length,tfpTmp);
	fclose(tfpTmp);
	tfpTmp=NULL;
	return 0;
}

static void CHKINPUT(char* pData)
{
	if (memcmp(pData,"null",4) == 0) (*pData) = '\0';
	return;
}

unsigned long _beginthread( void*( *start_address )( void * ), unsigned int stack_size, void *arglist );

#ifdef __cplusplus
}
#endif

#endif /* _UNITECCTEST_H_ */
